/* header file for olympics program - CSE465 */

#include "prodlist.h"
#include "linklist.h"

/* global constants */
#define MAX_EVENTS 100		/* max number of events */
#define MAX_ATHLETES 1000	/* max number of athletes */
#define EVENT_TEAMS	10		/* avg teams for one event */
#define TEAM_ATHLETES 10	/* avg athletes per team */


struct event { /* event structure */
	int id;	/* event ID */
   char *name;	/* event name */
   char score_type;	/* 'H' or 'L' */
   char gender;		/* 'M', 'F', 'B' */
   ProdPtrList *teams;	/* list of teams in event */
};

struct athlete { /* structure for athletes */
	int id;	/* athlete ID */
   char *fname;	/* first name */
   char *lname;	/* last name */
   LinkList *teams;	/* list of teams the athlete is on */
};

struct team { /* structure for teams */
	int id;	/* team ID */
   float score;	/* team score */
   int rank;		/* team rank */
   char *country;	/* team country */
   struct event *event;	/* pointer back to event */
   ProdPtrList *athletes;	/* list of athletes on team */
};

/*
 * how will you handle one person teams?
 * they way you have it now, either there would be
 * a bunch of teams from the same country.
 *
 * maybe you want to add a team name, in addition to a country
 * for single person teams, use the athlete name for team name
 *
 * you might also want a special flag for one person teams
 * that would simplify some of the logic you will have to write
 */

/*
 * function prototypes
 */

struct event *create_event(void);
struct team *create_team(void);
struct athlete *create_athlete(void);
struct athlete *find_create_athlete(struct athlete *list[], char *buf);
struct athlete *find_athlete_name(struct athlete *list[], char *fname, char *lname);
int get_num_athletes(void);
int read_line(FILE *fp, char *buf);

void display_event(struct event *e);
void display_team(struct team *t);
void display_athlete(struct athlete *a);


